<?
/*
###############################
#
# Advertising Page Manager plugin script for CC
# verified with CC versions 1.97
# http://www.jkirkpatrick.org/plugins
#
###############################
#
# Date: Jan 18, 2004
# Web: http://www.jkirkpatrick.org
# Mail: plugins@jkirkpatrick.org
#
###############################
#
#Copyright 2004 Jeremiah Kirkpatrick, All rights Reserved
#
###############################
*/
/* NOTE TO PROGRAMMERS
Currently this is a beta module class design, and may change when the other module class (or two) are created. All information about this class is commented through out the code so you can see what each nut and bolt does relative to it's purpose. For additional information, view the working pay systems and redemptions already created. In my opinion it's pretty streight foward if your familiar with OOP.
Most if not all of our database information can be stored in the predesigned database. Feel free to store additional information any other way you need too, just remember to ad a way to remove the information within the module. I've not dealt with, or seen all the different paysystems, however i've covered the basic necessities. Below is what you have to work with:
@mysql_query("CREATE TABLE `$this->table_config` (
 `name` VARCHAR( 50 ) NOT NULL , 			<--Pay system unique name, single word
 `active` TINYINT NOT NULL DEFAULT '0', 	<--Pay system activation 0=false, 1=true
 `markup` FLOAT (5,4),							<--Pay system markup value
 `account` VARCHAR( 50 ) NOT NULL,			<--Pay system unique account id
 `currency` VARCHAR( 10 ) NOT NULL,			<--Currency types of the paysystem if applicable
 `merchant` VARCHAR( 50 ) NOT NULL,			<--Your merchant name if applicable
 `ok_url` VARCHAR( 255 ) NOT NULL,			<--Good purchase return URL
 `cancel_url` VARCHAR ( 255 ) NOT NULL,	<--Canceled purchase return URL
 `status_url` VARCHAR ( 255 ) NOT NULL,	<--Status url for automatic paysystem notifiers if applicable
  PRIMARY KEY ( `name` )
 );");
 */
//$this->pay_modules_info[]=array("paysystem"=>"Paysystem Name", "classname"=>"advert_page", "automation"=>TRUE:FALSE); <-This is the global array which holds quick access information about the module class accessable by the plugin. "paysystem" would be the classes $formal_name, "classname" would be the $class_name, and "automation" would be $autocap.
class mod_psmgt
{
	var $id;						//some sort of unique id
	var $class_name;			//your module class name
	var $formal_name;			//The formal name of your paysystem
	var $version;				//Module Version
	var $automate=FALSE;		//Set at load time to be enabled/disabled automation per webmaster?
	var $autocap=FALSE;		//Is this module automation capable?
	var $img_path;				//An image path to your button... Not necessary if you put it in you hard code it into your form... infact it may go away in the future.
	var $base_path;			//Hard base path to the module. Use this variable to link up with other addon pages you create in a separate folder of course.
	var $table_config;		//Plugins configuration table, set by the constructor.
	var $table_items;			//Plugins item table, set by the constructor.
	var $table_groups;		//Plugins groups table, set by the constructor.
	var $author;				//Your name
	var $released;				//Date of Release
	var $email;					//Your eMail address
	var $home;					//Your Home Page
	var $settings=FALSE;		//This will hold the payment system information in a mysql array format.
	var $valid;					//(Currently Optional) Variable which holds the module's form state. Set to 'TRUE' if the get/posted data verifies correctly with the payment system or FALSE if it doesnt, or doesn't even check.
	var $paysystem_url;		//URL to the payment systems home page.
	var $active;
	function mod_psmgt($p_path, $config, $config_items='', $config_groups='')
	{
		//The base class constructor currently handles nothing, does nothing, is nothing, but may some day have a purpose. Your constructor on the other hand should set a few variables, or call this constructor like so: parent::mod_psmgt();. The choice is yours.
		$this->base_path=$p_path;
		$this->table_config=$config;
		$this->table_items=$config_items;
		$this->table_groups=$config_groups;
		return FALSE;
	}
	function mod_dat()
	{
		//This is called by the plugin when the user enters the paysystem management area. This is simply the menu which is displayed before them. No over-riding necessary for this function, but if you do over-ride it to individualize your menu row, keep in mind a neat professional appearance, and the table design of course.
		return "<tr bgcolor=#DDDDDD>
<td align=left valign=top><a href=\"".$_SERVER['PHP_SELF']."?p_load=advert_page&page=psmgt&module=".$this->class_name."&mpage=admin_config\">$this->formal_name</a></td>
<td align=left valign=top>".$this->version."</td>
<td align=left valign=top>".$this->released."</td>
<td align=left valign=top>".$this->author."</td>
<td align=left valign=top><a href=\"mailto:".$this->email."\">".$this->email."</a></td>
<td align=left valign=top><a href=\"".$this->home."\" target=_blank>".$this->home."</a></td>
</tr>";
	}
	function extra_value($value)
	{
		return FALSE;
	}
	function load_settings($force=0)
	{
		//This can be called anywhere in the module to load the settings prior to excuting code which requires them. If the settings are already loaded the function will simply send back the value of the class variable 'settings'. You can force a reload by calling the function and passing it '1'. No over-riding necessary for this function.
		if(!$this->settings||$force=1)
		{
			$this->settings=@mysql_fetch_array(@mysql_query("SELECT * FROM ".$this->table_config." WHERE `name`='".$this->class_name."' LIMIT 1"));
			$this->active=$this->settings['active'];
			if($this->autocap)
				$this->automate=$this->setting['automate'];
		}
		return $this->settings;
	}
	function unload_settings()
	{
		//Called by the plugin to unload the settings for whatever reason. No over-riding necessary for this function.
		unset($this->settings);
		unset($this->active);
	}
	function float2curency($value)
	{
		//Quick and easy function for turning a float into a string to place in forms or display on a page and keep the appropriate zeros. the problem with conventional methods was that it would turn 1.00 into 1. which is fine until you have 1.20 turned into 1.2 which doesn't really look right. This is simply a cosmetic function which can be called anywhere in the modules without the need to be over-ridden. If you have a better way of doing it, by all means, over-ride it.
		$tmp=strval(round($value, 2));
		if(!(strpos($tmp, '.') === FALSE))
		{
			$pre=strtok($tmp, '.');
			$post=strtok('');
		}else{
		$pre=$tmp;
		$post=array();
		}
		if(strlen($post) < 2);
		{
			for($i=0;$i<2;$i++)
			{
				if(!$post[$i])
					$post[$i]='0';
			}
		}
		if(is_array($post))
			$tmp=$pre.'.'.implode("",$post);
		else
			$tmp=$pre.'.'.$post;
		return $tmp;
	}
	function work_check()
	{
		//Over-ride this function to perform specific work requirement upon specific paysystem posts non-relative to automation... this function is necessary for redemptions, however redemptions are not automated... Returning 'TRUE' here will begin the next step in the process, auto_check(). This can be used for specifics such as 1) advanced logging, 2) Interupting the flow to display a form specific to the paysystem (eGold doesn't send an email address with the purchase notification, perhaps you could grab it here via the database or a form. At any rate, this function must return 'TRUE' to proceed to the next step in the process. If thiers no extra tasks you need to perform prior to validation, simply over-ride this function and return 'TRUE'.
		return FALSE;
	}
	function auto_check()
	{
		//Over-ride this function to check the appropriate get/post data for information likely to be found in either a IPN type post, or return to site type post. If found, validate the posted information and report back 'TRUE' if the work has been completed successfuly. Returning 'TRUE' here will run the desired event chosen by the W/M in admin.
		return FALSE;
	}
	function admin_config()
	{
		//Admin Configuration - Called by the module loader in admin.
	}
	function is_allowed($no_option)
	{
		//Simple function to deturmine if the paysystem has been disabled for specific items... This function does not need to be over-ridden, and shouldn't be as it works fine just as it is.
		if(!$this->settings)
			$this->load_settings();
		if(!$this->active)
			return FALSE;
		if(strpos($no_option, '|'.$this->class_name.'|')!==FALSE)
			return FALSE;
		else
			return TRUE;
	}
	function form($item_name, $item_num, $amount, $referer)
	{
		//Over-ride this function to draw your button form. Room can be made to fill in special feilds set aside in each payment system for the site owner. You will be provided with the basic information necessary to generate your form, and validate it upon return. Remember, you also have the class variables at your disposal for creating this form.
		return FALSE;
	}
	function validate_purchase()
	{
		//The suggested function to use to perform your get/post validation. Simply create an over-ride and call it from somewhere in auto_check().
		return FALSE;
	}
	function credit_ad()
	{
		//There is a possibility that I may use this... but then again their may not be... It all depends on which route I decide to take for automation... This function should not be depended upon until I decide which way I'm going to go with it...
		return FALSE;
	}
	function notify_admin($setting, $item, $group, $charged, $type, $user)
	{
		//Optionaly eMail admin about purchases, but could also notify them of form validation failures and what not. It's not necessary to use this specific funtion for this purpose however, it does make the code easier to follow because it will conform to module standards. Over-ride this function to create an email to send the webmaster.
		return FALSE;
	}
	function notify_buyer()
	{
		//Optionaly eMail the user about their purchases. It's not necessary to use this specific funtion for this purpose however, it does make the code easier to follow because it will conform to module standards. Over-ride this function to create an email to send the user upon successful purchase.
		return FALSE;
	}
}